/*
 *	@(#) systm.h 1.3 86/12/17 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/*
 * Random set of variables used by more than one routine.
 */
inodep_t rootdir;		/* pointer to inode of root directory */
struct proc *runq;		/* head of linked list of running processes */
extern struct proc *curproc;	/* current proc */
struct proc *Hogproc;           /* if non-NULL, schedule only this process */
short   cputype;                /* type of cpu */
time_t	lbolt;			/* time in HZ since last boot */
time_t	time;			/* time in sec from 1970 */
int     Hz;                     /* configurable clock speed */
int     Timezone;               /* configurable timezone */
int     Dstflag;                /* configurable DST flag  */

int	mpid;			/* generic for unique process id's */
char	runin;			/* scheduling flag */
short	runout;			/* scheduling flag */
char	runrun;			/* scheduling flag */
char    runtxt;                 /* scheduling flag */
char	curpri;			/* more scheduling */
unsigned maxmem;		/* actual max memory per process */
paddr_t	physmem;		/* physical memory on this CPU */
daddr_t	swplo;			/* block number of swap space */
int	nswap;			/* size of swap space */
int	updlock;		/* lock for sync */
daddr_t	rablock;		/* block to be read ahead */
int     Cmask;                  /* default creation mask */
extern	char	regloc[];	/* locs of saved user registers (trap.c) */
extern short	reglocc;	/* size of regloc array */
dev_t	rootdev;		/* device of the root */
dev_t	swapdev;		/* swapping device */
dev_t	pipedev;		/* pipe device */
int	blkacty;		/* active block devices */

/* machine dependent part */


/* function defs */
dev_t getmdev();
daddr_t	bmap();
inodep_t ialloc();
inodep_t iget();
inodep_t owner();
inodep_t maknode();
inodep_t namei();
struct buf *alloc();
struct buf *getblk();
struct buf *getablk();
struct buf *bread();
struct buf *breada();
filep_t getf();
filep_t falloc();
int	uchar();

extern	char	maxmask[]; 	/* 8259 dependent flag set in init8259.c*/
extern paddr_t kmemstart;


/*
 * Structure of the system-entry table
 */

#ifdef M_I386

extern struct sysent {
	unsigned char	sy_ret;		/* Type of return value (int, long,
						pointer) */
	unsigned char	sy_cvtarg;	/* 386: specifies whether args need
					   to be converted, based on u.u_renv */
	unsigned char	sy_nlarg286;	/* Large model 286: number of word args
					   (args are on user stack) */ 
	unsigned char	sy_nmarg286;	/* Any model 386: unused */ 
					/* Small/Middle model 286: max number 
					   of word args passed on user stack, 
					   instead of in registers */
	unsigned	sy_argmask;	/* mask for args */
	int		(*sy_call)();	/* handler */
} sysent[];

#else

struct sysent {
	char	 sy_nlarg;	/* large model arg word count */
	char	 sy_nmarg;	/* middle model arg words (if reg overflow) */
	unsigned sy_argmask;	/* mask to show type of argument(s) */
	int	 (*sy_call)();	/* handler */
};

/*	idt table entry format */

#ifdef M_I286
struct idt {
	int	(far *i_func)();
	char	i_hbase;
	char	i_type;
	short	i_pad;
};
#endif

extern short icode[];
ushort szicode;

#endif
