
/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */
/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL CPU'S AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

#define NOEXTGDT

#include  "../h/param.h"
#include  "../h/types.h"
#include  "../h/sysmacros.h"
#include  "../h/systm.h"
#include  "../h/dir.h"
#include  "../h/signal.h"
#include  "../h/seg.h"
#include  "../h/page.h"
#include  "../h/user.h"
#include  "../h/mmu.h"

#ifdef SYSINFO
#include  "../h/sysinfo.h"
struct sysinfo sysinfo;
struct syswait syswait;
#endif

int nfs1=0;	/* DSA */
int nfs2=0;	/* DSA */
int do_nfc;	/* DSA */

paddr_t	kmemstart;

#ifndef M_I8086
int Ngdt=NGDT;
#endif

#ifdef M_I286

extern 	struct tss	tss, sftss;

#define KDSOFF(x)	((unsigned) (x))

#define DCA_TSS		(DST_ATASK  | DSA_PRESENT)		/* tss */
#define DCA_CGATE	(DST_CGATE  | DSA_PRESENT | DSA_RING3)	/* call gate */

#define GDTLIM	(sizeof(gdt) - 1)			/* gdt limit */
#define STKLIM	(KSSIZE - 1)				/* ksp limit */

struct dtab gdt[NGDT] = {
    { 0, 0, 0, 0, 0 },				/* 0 Empty slot  */
    { GDTLIM, KDSOFF(gdt), 0, DSA_DATA, 0 },	/* 8 GDT alias */
    { IDTLIM, 0, 0, DSA_DATA, 0 },		/* 10 IDT alias */
    { 0, 0, 0, 0, 0 },				/* 18 kernel ds */
    { 0, 0, 0, 0, 0 },				/* 20 kernel auxdata 1 */
    { 0, 0, 0, 0, 0 },				/* 28 kernel auxdata 2 */
    { 0, 0, 0, 0, 0 },				/* 30 kernel cs SEG 1 */
    { 0, 0, 0, 0, 0 },				/* 38 kernel cs SEG 2 */
    { 0, 0, 0, 0, 0 },				/* 40 kernel cs SEG 3 */
    { 0, 0, 0, 0, 0 },				/* 48 kernel cs SEG 4 */
    { 0, 0, 0, 0, 0 },				/* 50 kernel cs SEG 5 */
    { STKLIM, KDSOFF(&u), 0, DSA_DATA, 0 },	/* 58 kernel ss  */
    { TSSLIM, KDSOFF(&tss), 0, DCA_TSS, 0 },	/* 60 tss */
    { TSSLIM, KDSOFF(&sftss), 0, DCA_TSS, 0 },	/* 68 stack fault tss */
    { 0, 0, 0, 0, 0 },				/* 70 Kernel work */
    { 0, 0, 0, 0, 0 },				/* 78 Kernel work */
    { 0, 0, 0, 0, 0 },				/* 80 Kernel work */
    { 0, 0, 0, 0, 0 },				/* 88 Map Work fuss */
    { 0, 0, 0, 0, 0 },				/* 90 Kernel work (copyio) */
    { 0, 0, 0, 0, 0 },				/* 98 CLDT_SEL */
 /* { ftooff(kentry), ftoseg(kentry), 1, DCA_CGATE, 0 }, */
    { 0, 0, 1, DCA_CGATE, 0 },			/* A0 Kernel Entry */
    { 0, 0, 0, 0, 0 },				/* A8 Kernel work (swapper) */
    { 0, 0, 0, 0, 0 },				/* B0 Kernel work (swapper) */
    { 0, 0, 0, 0, 0 },				/* B8 Kernel work (swapper) */
    { 0, 0, 0, 0, 0 }				/* C0 Kernel work (swapper) */
    /* the rest of the gdt entries are initialized at run time */
};

/*
 * Permanently mapped to the current proc's ldt array.
 * ldt[FIRSTU_SEL/SELSZ] references the FIRSTU_SEL ldt.
 */
fdesc_t	*ldt = (fdesc_t *) sotofar(ULDT_SEL, 0);

/*
 * Permanently mapped to the current proc's ldt info array.
 * This array is parallel to the ldt one and holds extra information
 */
struct ldtinf far *ldtinfo = (struct ldtinf far *) sotofar(ULINFO_SEL, 0);

#endif	/* M_I286 */

